const path = require('path');
const fs = require('fs');


const htmlTemp = `<!DOCTYPE html>
<html lang="en">

<head>
    <title></title>
    <meta charset="UTF-8">
    <meta name="viewport" content="width=device-width, initial-scale=1">
    <link href="./style/components.css" rel="stylesheet">
    <link href="./style/main.css" rel="stylesheet">
    <script src="https://code.jquery.com/jquery-3.2.1.min.js"></script>]
    <script src="https://static.360buyimg.com/smart/jdsmart-1.0.3.js"></script>
    <!--<script src="./sdk/fake-sdk.js"></script>-->
    <script src="./sdk/sdk.js"></script>
</head>

<body>
    <!--开心的添加代码吧-->
    <!--默认引用jd-smart-ui-->

    
    

   
   
    <script src="./main.js"></script>
</body>
</html>
`;


const mainTemp = `
    var APP = {
        Device_Id: null,
        Feed_Id: null,
        Trans_Data: {},
        Device_Status: null,
        /**
         * 初始化
         */
        init:function(){
            var _ = this;
            JDSMART.ready(function() {
                _.initData();
                _.bindEvent();
                setInterval(function() {
                    _.getInfo();
                }, 4000);
            });
        },
        /**
         * 
         * 初始化数据
         */
        initData:function(){
            var _ = this;
            JDSMART.io.initDeviceData(function(res) {
                if (typeof res === "string") {
                    res = JSON.parse(res);
                }
                _.Device_Id = res.device.device_id;
                _.Feed_Id = res.device.feed_id;
                _.Device_Status = res.device.status;
                _.transforData(res.streams);
                _.setDeviceStatus(_.Device_Status);
            });
        },
        bindEvent:function(){

        },
        /**
         * 获取快照（获取数据）
         */
        getInfo:function(){
            var _ = this;
            JDSMART.io.getSnapshot(function(res) {
                if (typeof res === "string") {
                    res = JSON.parse(res);
                }
                _.Device_Status = res.status;
                _.setDeviceStatus(_.Device_Status);
                _.transforData(res.streams);

            }, function(error) {
                JDSMART.app.toast({
                    message: error
                });
            });
        },
        /**
         * 转换数据
         */
         transforData: function(data) {
            var _ = this;
            if (typeof data === "string") {
                data = JSON.parse(data);
            }
            data.forEach(function(element, index) {
                this.Trans_Data[element['stream_id']] = element['current_value'];
            }, this);
            this.renderView();
        },
        /**
         * 设置状态
         */
        setDeviceStatus: function(status) {
            var isOnline = true;
            if (status === "1") {
                isOnline = true;
                console.info('设备在线');
            } else {
                isOnline = false;
                console.info('设备不在线');
            }
            JDSMART.app.config({
                showBack: true, // 返回按钮，false是隐藏，true是显示
                showShare: true,
                showMore: true,
                showOnline: isOnline // true---显示：表示设备不在线   false---不显示：表示设备在线
            });
        },
        /**
         * 控制下发函数
         */
        sendCommand: function(cmd) {
            var _ = this;
            if (cmd) {
                JDSMART.io.controlDevice(cmd, function(res) {
                    if (res) {
                        if (typeof res === "string") {
                            res = JSON.parse(res);
                        };
                        _.transforData(res.result.streams);
                    }
                }, function(error) {

                });
            }
        },
        renderView:function(){
            //渲染UI   
        }
        /**
         * 
         * 剩下的自由发挥吧,么么哒~^.^~
         */
    }
    APP.init()

`;

const cssTemp = `
    
`;



var argv = require("minimist")(process.argv.slice(2), {
    alias: {
        'silent': 's',
        'port': 'p',
        'hostname': 'h',
        'dir': 'd',
        'log': 'l',
        'fallback': 'f'
    },
    string: ['port', 'hostname', 'fallback'],
    boolean: ['silent', 'log'],
    'default': {
        'port': 8000,
        'dir': process.cwd()
    }
});

let BASEPATH = argv.dir;

let modelName;

exports.CreateJD = (model) => {
    console.log("==============================创建京东项目模板=========================");
    console.log("=========默认引用jd-smart-ui=======");
    modelName = model;
    createProject();
}

function createProject() {
    fs.readdir(BASEPATH, (err, files) => {
        if (!files.includes(modelName)) {
            fs.mkdirSync(`${BASEPATH}/${modelName}`);
            fs.mkdirSync(`${BASEPATH}/${modelName}/sdk`);
            copyfile([{
                from: path.join(__dirname, 'sdk/sdk.js'),
                to: path.join(BASEPATH + `/${modelName}/sdk/sdk.js`)
            }, {
                from: path.join(__dirname, 'sdk/fake-sdk.js'),
                to: path.join(BASEPATH + `/${modelName}/sdk/fake-sdk.js`)
            },{
                from: path.join(__dirname, 'sdk/components.css'),
                to: path.join(BASEPATH + `/${modelName}/sdk/components.css`)
            }]);
            createHtml();
            createJS();
            createStyle();
        } else {
            console.log(`${modelName}已存在`);
        }
    });

}

function copyfile(arr) {
    for (let i in arr) {
        const readStream = fs.createReadStream(arr[i].from);
        const writeStream = fs.createWriteStream(arr[i].to);
        readStream.pipe(writeStream);
    }
}

function createHtml() {
    fs.writeFile(`${BASEPATH}/${modelName}/index.html`, htmlTemp, 'utf8', (err) => {
        if (err) {
            throw err;
        }
        console.log('>>创建index.html');
    });

}

function createJS() {
    // fs.writeFile(`${BASEPATH}/${modelName}/app.js`, jsTemp, 'utf8', (err) => {
    //     if (err) {
    //         throw err;
    //     }
    //     console.log('>>创建app.js');
    // });
    fs.writeFile(`${BASEPATH}/${modelName}/main.js`, mainTemp, 'utf8', (err) => {
        if (err) {
            throw err;
        }
        console.log('>>创建main.js');
    });

}


function createStyle() {
    fs.mkdir(`${BASEPATH}/${modelName}/style`, () => {
        createStyleFile();
    });

}

function createStyleFile() {
    fs.writeFile(`${BASEPATH}/${modelName}/style/main.css`, cssTemp, 'utf8', (err) => {
        if (err) {
            throw err;
        }
        console.log('>>创建main.css');
    });

}