define(['text!./stepNoTip.html'], function(stepNoTip) {
	var doc = $(document);
	var stepCommon = function(config, data) {
		var workMap = {
			array: [],
			workStep: ""
		};
		var configTipValueArray = [];
		var configKey = config.key;
		var configCookData = config.cookData;//cookData配置项
		var configValuesLength = getJsonLength(configCookData).toString();

		var workStep;
		if (configKey) {
			var dataValue = data && data[configKey].value;
		}

		function getJsonLength(jsonData) {
			return Object.keys(jsonData).length;
		}

		stepCommon.prototype.init = function() {
			if (isNaN(renderData.data.workStep)) return;
			var html = _.template(stepNoTip)(renderData);
			$('.bind_handle_workStep').html(html);
		};
		stepCommon.prototype.setTemplate = function() {
			for (var key in configCookData) {
				var configValueLabels = configCookData[key].valueLabels;
				var configDescription = configCookData[key].description;
				var configUrl = configCookData[key].url;
				if (dataValue){
					if (typeof configCookData[key].values==='object'){
						configCookData[key].values.some(function (item) {
							if (item==dataValue){
								workStep = key * 1 + 1;
								$('.step-now').html(workStep);
								$('.step-all').html(configValuesLength);
							}
						});
					}else if (dataValue == configCookData[key].values) {
						workStep = key * 1 + 1;
						$('.step-now').html(workStep);
						$('.step-all').html(configValuesLength);
					}
				}

				workMap.array.push({
					configValuesLength: configValuesLength,
					configValueLabels: configValueLabels,
					configDescription: configDescription,
					configUrl: configUrl
				});
				workMap.workStep = parseInt(workStep);
			}
		};
		stepCommon.prototype.bindEvent = function(renderData) {
			for (var key in renderData.data.array) {
				var configTipValue = renderData.data.array[key].configDescription && renderData.data.array[key].configDescription;
				var moveTopNum = renderData.data && renderData.data.workStep;
				var configLoadPage = renderData.data.array[key] && renderData.data.array[key].configUrl;
				configTipValueArray.push({
					configTipValue: configTipValue
				});
			}
			if (moveTopNum == undefined) {
				return;
			}

			var tipCount = 0;
			for (var key in configTipValueArray) {
				if (configTipValueArray[key].configTipValue != '') {
					tipCount = tipCount + 1;
				}
			}

			var tipIcon = $('.ui-item-title-row1 .alink_iconfont');
			var clickTip = $('.clickTip');
			var clickTipContent = $('.clickTip-content');
			var arrowDown = $('.arrow-down');
			for (var i = 0; i < tipCount; i++) {
				if (tipIcon.length == 0) {
					//如果没有tipIcon
					return;
				}
				var clickTipLeft = tipIcon.eq(i).offset().left - 5;
				var clickTipTop = clickTipContent.eq(i).offset().height;
				var clickTipContentWidth = clickTipContent.eq(i).offset().width;
				clickTip.eq(i).css({
					'top': -clickTipTop + 'px'
				});
				arrowDown.eq(i).css({
					'left': clickTipLeft + 'px'
				});
				if (clickTipContentWidth < 260) {
					var clickTipContentMarginLeft = (260 - clickTipContentWidth) / 2;
					clickTipContent.eq(i).css({
						'margin-left': clickTipContentMarginLeft + 'px'
					});
				}

			}
			tipIcon.click(function(e) {
				//取消事件默认行为
				e.preventDefault();
				e.stopPropagation();
				var THIS = e.target;
				$(THIS).next().removeClass('visibility');
				$(THIS).parent().parent().parent().parent().siblings().find('.clickTip').addClass('visibility')
			});
			doc.on('click', tipIcon, function() {
			 		console.log(tipIcon.eq(this));

            });
			doc.on('click', 'body', function() {
				clickTip.addClass('visibility');
			});

			for (var key in configLoadPage) {
				if (configLoadPage[key]) {
					$('.top-tip').click(function() {
						DA.loadPage(configLoadPage[key]);
					});
				}
			}

			//rightButton render
			/*左边未对齐（因为在不同手机下iconfont大小不同导致的未对齐）*/
			 //var iconHeight = $('.alink_iconfont').offset().height;
			 //var iconBorder = 54 - iconHeight;
			 //$('.icon-step .left-icon').css({'border-bottom-width':iconBorder+'px'})

		};
		this.setTemplate(config, data);
		var renderData = {
			data: workMap
		};
		this.init();
		this.bindEvent(renderData);
	};
	DA.stepCommon = stepCommon;
	return DA.stepCommon;
	//asevented.call(stepCommon);
});