define(['../stepCommon/stepCommon.js', '../stepCommon/workStatusCommon.js', '../stepCommon/errorTip.js', '../topBar.js'], function (stepCommon, workStatusCommon, errorTip, topBar) {
    var doc = $(document),
        btnOperateDom = $('.bind_handle_switch_btn'),
        syncStatusDom = $('#J_loading');
    var stepCommonConfig = {
        key: 'WorkStatus',
        cookData: [
            {
                'values': ['3', '4'],
                'valueLabels': '洗涤中'
            }, {
                'values': ['5', '6'],
                'valueLabels': '漂洗中'
            }, {
                'values': ['7', '8'],
                'valueLabels': '脱水中'
            }
        ]
    };

    return {
        init: function () {
            var self = this;
            //判断安卓版本
            var isandroidVersion = self.androidVersion();
            if (isandroidVersion) {
                $('.work-circle').css({
                    'background-image': 'url(https://gw.alicdn.com/tps/TB1VyyEKVXXXXbtaXXXXXXXXXXX-570-570.png)'
                });
            }
            //实时更新的数据
            self.bindPushData();
            //设备第一次上报的数据
            self.getDeviceStatus();
            //绑定事件
            self.bindEvent()
        },
        bindEvent: function () {
            var self = this;

            doc.on('click', '.btn-off', function () {
                //关机
                self.syncStatus();
                DA.setDeviceStatus(DA.uuid, {"OnOff_Power": {"value": "0"}});
            });
            doc.on('click', '.btn-pause', function () {
                //暂停
                self.syncStatus();
                DA.setDeviceStatus(DA.uuid, {"OnOff_Start": {"value": "0"}});
            });
            doc.on('click', '.btn-continue', function () {
                //继续
                self.syncStatus();
                DA.setDeviceStatus(DA.uuid, {"OnOff_Start": {"value": "1"}});
            });
                //我知道了
            doc.on('click', '.i-know', function () {
                self.syncStatus();
                DA.setDeviceStatus(DA.uuid, {"WorkFinish": {"value": "0"}});
                DA.back();
            });
        },
        render: function (data) {
            var self = this;
            if (data.onlineState) {
                if (DA.getUI('offNet')) {
                    if (data.onlineState.value === 'on') {
                        DA.getUI('offNet').hideUI();
                    } else {
                        return DA.getUI('offNet').showUI();
                    }
                }
            }

            //异常界面处理
            if (data.ErrorCode) {
                self.errorContent(data);
            }
            if (!data.WorkStatus) return;
            var childLock = DA.getUI('childLockSwitch');
            if (childLock) {
                if (data.OnOff_ChildLock) childLock.setValue(data.OnOff_ChildLock.value);
                data.WorkStatus.value === '9' ? childLock.disabled() : childLock.enabled();
            }
            if (stepCommonConfig.cookData.length!==1){
                switch (data.WorkMode.value){
                    case '9':
                    case '12':
                        stepCommonConfig.cookData=[{
                            'values': ['3', '4'],
                            'valueLabels': '洗涤中'
                        }];
                        break;
                    case '10':
                        stepCommonConfig.cookData=[{
                            'values': ['5', '6'],
                            'valueLabels': '漂洗中'
                        }];
                        break;
                    case '11':
                        stepCommonConfig.cookData=[{
                            'values': ['7', '8'],
                            'valueLabels': '脱水中'
                        }];
                        break;
                }
            }

            if (data.WorkStatus.value === '2' && stepCommonConfig.cookData[0].values !== '2') {
                stepCommonConfig.cookData.unshift({
                    'values': '2',
                    'valueLabels': '预约中'
                });
            }
            if (data.OnOff_DrainWater.value === '1' && stepCommonConfig.cookData[stepCommonConfig.cookData.length - 1].values !== '9') {
                stepCommonConfig.cookData.push({
                    'values': '9',
                    'valueLabels': '排残水中'
                });
            }
            self.stepCommonConfigFn(data);

            //步骤组件
            self.stepCommonFn(data);
            //工作状态组件
            self.workStatusCommonFn(data);
            //根据WorkStatus渲染面板
            self.renderWorkStatus(data);
        },
        stepCommonConfigFn: function (data) {
            var self = this;
            self.stepCommonConfig = stepCommonConfig;
        },
        workStatusCommonFn: function (data) {
            var self = this;
            var dataValue = data.WorkStatus.value; //当前状态的key值
            var workStatusCookData = self.stepCommonConfig.cookData; //步骤组件定义的configData

            /*工作时间倒计时处理*/

            var workStatusConfig = {
                "p1": {
                    "vUnit": "",
                    "content": getP1()
                },
                "p2": {
                    "vUnit": "",
                    "content": getP2()
                },
                "p3": {
                    "vUnit": "",
                    "content": getP3()
                },
                "p4": {
                    "vUnit": "",
                    "content": getP4()
                },
                "p5": {
                    "vUnit": "",
                    "content": getP5()
                },
                'pause': getPause()
            };

            function getPause() {
                return '468'.indexOf(dataValue) !== -1;
            }

            function getP1() {
                if (!getPause()) {
                    return '<i class="alink_iconfont fontSize">&#xe697;</i><span>剩余时间</span>';
                }
            }

            function getP2() {
                if (!getPause()) {
                    var workTime;
                    if (dataValue === '2') {
                        workTime = data.TimeMeter_Finish.value;
                    } else if (dataValue === '9') {
                        workTime = data.DrainTime_Left.value;
                    } else {
                        workTime = data.WorkTime_Left.value;
                    }
                    return '<div class="work-time-value"><i class="hour">' + (dataValue === '2' ? workTime + '</i><em>小时</em>' : workTime.substr(0, 2) + '</i><em>小时</em><i class="minute">' + workTime.substr(3, 2) + '</i><em>分钟</em>') + '</div>';
                }
            }

            function getP3() {
                var cookData;
                if (!getPause() && dataValue) {
                    cookData = stepCommonConfig.cookData;
                    for (var i = 0; i < cookData.length; i++) {
                        for (var j = 0; j < cookData[i].values.length; j++) {
                            if (cookData[i].values[j] === dataValue) {
                                return cookData[i].valueLabels;
                            }
                        }
                    }
                }
            }

            function getP4() {
                var hour, min, timeMeterFinishLeft;
                var workTime = data.WorkTime_Left.value;
                var cookData = stepCommonConfig.cookData;

                if (!getPause()) {
                    if (cookData[cookData.length - 1].values === '9') {
                        workTime = workTime.split(':');
                        workTime = (+workTime[0]) * 60 + (+workTime[1]) + 10;
                        workTime = (workTime / 60 > 9 ? '' + parseInt(workTime / 60) : '0' + parseInt(workTime / 60)) + (workTime % 60 > 9 ? ':' + workTime % 60 : ':0' + workTime % 60);
                    }
                    if (dataValue === '9') {
                        workTime = data.DrainTime_Left.value;
                    }
                    timeMeterFinishLeft = data.TimeMeter_Finish.value;
                    hour = (+workTime.substr(0, 2)) + (+timeMeterFinishLeft);
                    min = workTime.substr(3, 2);
                    return '( 总剩余 ' + (hour < 10 ? '0' + hour + ' 小时' + min + ' 分钟' : hour + ' 小时' + min + ' 分钟') + ' )';
                }
            }

            function getP5() {
                return '';
            }

            var workStatusCommon = new DA.workStatusCommon(workStatusConfig);
        },
        getDeviceStatus: function () { //第一次加载时get数据
            var self = this;
            DA.getDeviceStatus(DA.uuid, function (d) {
                self.syncStatus();
                self.render(d);
                self.syncStatusFinish();
            });
        },
        bindPushData: function () {
            var self = this;
            DA.bindPushData({
                deviceStatusChange: function (d) {
                    self.render(d);
                    self.syncStatusFinish();
                },
                netWorkStatusChange: function (data) {
                    DA.netWorkStatus = data;
                    if (data == false) {
                        DA.getUI('offlineToast').showUI();
                    }
                }
            });
        },

        stepCommonFn: function (data) {
            var self = this;
            //工作步骤
            var stepCommon = new DA.stepCommon(stepCommonConfig, data);
        },
        renderWorkStatus: function (data) { //根据不同的工作状态值渲染页面
            var self=this;
            if (data.WorkStatus && data.WorkStatus.value !== '9' && data.WorkFinish && data.WorkFinish.value == '1') {
                $('.product-img').removeClass('hidden');
                $('.work-timeOver').removeClass('hidden');
                $('.work-on').addClass('hidden');
                btnOperateDom.html('<div class="ui-switch-btn-group"><div class="ui-switch-btn i-know on">我知道了</div></div>');
                return;
            }
            var WorkStatusValue = data.WorkStatus.value;
            switch (WorkStatusValue) {
                case '0':
                case '1':
                    DA.back();
                    break;
                case '2':
                case '9':
                    btnOperateDom.html('<div class="ui-switch-btn-group"><div class="ui-switch-btn btn-off on">关机</div></div>');
                    break;
                case '3':
                case '5':
                case '7':
                    btnOperateDom.html('<div class="ui-switch-btn-group"><div class="ui-order-btn btn-off on">关机</div><div class="ui-switch-btn half-width on btn-pause">暂停</div></div>');
                    break;
                case '4':
                case '6':
                case '8':
                    btnOperateDom.html('<div class="ui-switch-btn-group"><div class="ui-order-btn btn-off">关机</div><div class="ui-switch-btn half-width btn-continue">继续</div></div>');
                    break;
            }

            //页面滑动native bar颜色问题
            self.setBodyHeight();
        },
        androidVersion: function () {
            var self = this;
            var u = window.navigator.userAgent;
            var num;
            var isiOS = !!u.match(/\(i[^;]+;( U;)? CPU.+Mac OS X/); //ios终端
            var isandroid = u.indexOf('Android') > -1 || u.indexOf('Linux') > -1;
            //移动端
            if (isiOS) {
                return false;
            }
            if (isandroid) {
                //android
                num = u.substr(u.indexOf('Android') + 8, 3);
                var androidVersion = {
                    "type": "Android",
                    "version": num
                };
                console.log('安卓版本:' + androidVersion['version']);
                return androidVersion['version'] < 4.3;
            }
        },

        errorContent: function (data) {
            var self = this;
            var errorCode = data.ErrorCode.value;
            if (data.ErrorCode) {
                if (data.ErrorCode.value !== '0') {
                    self.errorCommon(data);
                    document.addEventListener('touchmove', self.preventDefault, true);
                } else {
                    $('.error-wrapper').remove();
                    document.removeEventListener('touchmove', self.preventDefault, true);

                }
            }
        },
        errorCommon: function (data) {
            var errorConfig = {
                key: 'ErrorCode',
                values: ['1', '2', '3', '4', '5', '6', '7'],
                errorText: [
                    '洗衣机故障',
                    '不进水',
                    '不排水',
                    '不脱水',
                    '门盖没有关闭',
                    '门盖无法打开',
                    '门盖无法打开'
                ],
                contact: '请放心，拨打三洋洗衣机服务热线为您解决',
                phoneNum: '4008899360'
            };
            console.log('错误提示的配置项:' + errorConfig);
            var errorTip = new DA.errorTip(errorConfig, data);
        },
        syncStatus: function () {
            syncStatusDom.removeClass('hidden');
        },
        syncStatusFinish: function () {
            syncStatusDom.addClass('hidden');
        },
        preventDefault: function (e) {
            e.stopPropagation();
            e.preventDefault();
        },
        setBodyHeight: function () {
            var height=$(document.body).height();
            if (height>630 && height<640){
                $(document.body).addClass('min-600');
            }
        }
    }
});